/*
 *  Tract Viewer converts a Nifti Image to an unsructed grid 
 *
 */

#include <string>

#include "DataTypes.h"
#include "NIFTIIntImage.h"
#include "NIFTIFloatImage.h"
#include "VTKVisualization.h"
#include "vtkGenericRenderWindowInteractor.h"
#include "vtkInteractorStyleTrackballActor.h"
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <sstream>
#include <cstdio>

#include <vtkCallbackCommand.h>
#include <vtkCommand.h>

#include <iostream>
#include<string>

#include <unistd.h>
#include <vtkWindowToImageFilter.h>
//vtkPNGWriter
#include <vtkInteractorStyleSwitch.h>

#define GetCurrentDir getcwd

#include <vtkMatrix4x4.h>

#include <vtkContourFilter.h>


class snapShotEventClass : public vtkCommand
{
	
	
	
	virtual void Execute	( 	vtkObject * 	caller, unsigned long 	eventId, void * 	callData) 	
	{
		
		vtkRenderWindowInteractor *iren = 
		static_cast<vtkRenderWindowInteractor*>(caller);
		//cout << "Key:"  << keyCode<< endl;	
		if (iren->GetShiftKey())
		{
			cout << "Shift Pressed Modify Pollhemus Data" << endl;
			//assembly.SetOrigin(5, 10, 15)
			//assembly.AddPosition(5, 0, 0)
			//assembly.RotateX(15)
			//double *scaleP=PollhemusAssembly->GetScale();
			//double scale=(scaleP[0])+10;
			vtkSmartPointer<vtkMatrix4x4> m = vtkSmartPointer<vtkMatrix4x4>::New();
			PollhemusAssembly->GetMatrix(m);
			for (int i=0;i<4;i++)
				cout << m->Element[i][0] << " " << m->Element[i][1] << " " << m->Element[i][2] << " " << m->Element[i][3] << " " << endl;
			 std::cout << "Matrix: " << endl << *m << std::endl;	
					
			
			
			switch (eventId)
			{
					
				case LeftButtonPressEvent  : 
					cout << "Shift LeftButtonPressEvent" << endl;
					//PollhemusAssembly->RotateX(15);
					break;
			
				case MiddleButtonPressEvent: 
					cout << "Shift MiddleButtonPressEvent" << endl;
					//PollhemusAssembly->SetScale(scale);
					break;
				
				case RightButtonPressEvent :
					cout << "Shift RightButtonPressEvent";
			
					break;
			};
			return;
		
		}
		else
			
		{
			cout << "Not pressed " << endl;
		};
		
		cout << "Event ID:" << eventId << endl;
		
		
		
		
		
		
		vtkWindowToImageFilter *snapShot=vtkWindowToImageFilter::New	( 	 	);
		snapShot->	SetInput(renWin);
		vtkPNGWriter *wr=vtkPNGWriter::New();
		wr->SetInputConnection(snapShot->GetOutputPort());
		
	
		switch (eventId)
		{
			
			case LeftButtonPressEvent  : 
			  cout << "LeftButtonPressEvent" ;
			  if (planeActor!=NULL)
			    {
			     vtkImageData *data= planeActor->GetInput();
			     int ex1,ex2,ey1,ey2,ez1,ez2;
			     int dex1,dex2,dey1,dey2,dez1,dez2;
			    data-> GetExtent (ex1,ex2,ey1,ey2,ez1,ez2);
			    int extend[6];
			    planeActor -> GetDisplayExtent (extend);
			    dex1=extend[0];dex2=extend[1];dey1=extend[2];dey2=extend[3];
			    dez1=extend[4];dez2=extend[5];

		    
			  int middle;
			  switch (planeAxis)
			    {
			    case 1:
			      dex1=dex1+1;
			      dex2=dex2+1;
			      if (dex1>ex2) {dex1=ex1;dex2=ex1;};
			      dey1=ey1;dey2=ey2;dez1=ez1;dez2=ez2;
			      break;
			    case 2:
			      dey1=dey1+1;
			      dey2=dey2+1;
			      if (dey1>ey2) {dey1=ey1;dey2=ey1;};
			      dex1=ex1;dex2=ex2;dez1=ez1;dez2=ez2;
			      break;
			    case 3:
			      dez1=dez1+1;
			      dez2=dez2+1;
			      if (dez1>ez2) {dez1=ez1;dez2=ez1;};
			      dex1=ex1;dex2=ex2;dey1=ey1;dey2=ey2;
			      break;
			    default:
			     dez1=dez1+1;
			      dez2=dez2+1;
			      if (dez1>ez2) {dez1=ez1;dez2=ez1;};
			      dex1=ex1;dex2=ex2;dey1=ey1;dey2=ey2;


			      break;
			      


			    };
					  
			  planeActor ->SetDisplayExtent(dex1,dex2, dey1,dey2, dez1,dez2);
			  break;	
			    };
	
			case MiddleButtonPressEvent: cout << "MiddleButtonPressEvent" << endl;
				char buffer[1024];
				sprintf(buffer,"SnapShot%d.png",k);k++;
				wr->SetFileName( buffer);
				wr->Write();
				;break;
				
				
			case RightButtonPressEvent :
			  cout << "RightButtonPressEvent";

	 
			  if (planeActor!=NULL)
			    {
			     vtkImageData *data= planeActor->GetInput();
			     int ex1,ex2,ey1,ey2,ez1,ez2;
			     int dex1,dex2,dey1,dey2,dez1,dez2;
			    data-> GetExtent (ex1,ex2,ey1,ey2,ez1,ez2);
			    int extend[6];
			    planeActor -> GetDisplayExtent (extend);
			    dex1=extend[0];dex2=extend[1];dey1=extend[2];dey2=extend[3];
			    dez1=extend[4];dez2=extend[5];
		    
			  int middle;
			  switch (planeAxis)
			    {
			    case 1:
			      dex1=dex1-1;
			      dex2=dex2-1;
			      if (dex1<ex1) {dex1=ex1;dex2=ex1;};
			      dey1=ey1;dey2=ey2;dez1=ez1;dez2=ez2;
			      break;
			    case 2:
			      dey1=dey1-1;
			      dey2=dey2-1;
			      if (dey1<ey1) {dey1=ey1;dey2=ey1;};
			      dex1=ex1;dex2=ex2;dez1=ez1;dez2=ez2;
			      break;
			    case 3:
			      dez1=dez1-1;
			      dez2=dez2-1;
			      if (dez1<ez1) {dez1=ez1;dez2=ez1;};
			      dex1=ex1;dex2=ex2;dey1=ey1;dey2=ey2;
			      break;
			    default:
			     dez1=dez1-1;
			      dez2=dez2-1;
			      if (dez1<ez1) {dez1=ez1;dez2=ez1;};
			      dex1=ex1;dex2=ex2;dey1=ey1;dey2=ey2;
			      break;};
				  
			  planeActor ->SetDisplayExtent(dex1,dex2, dey1,dey2, dez1,dez2);
			    }
			  break;
				
		};
		
		
		
	};
	
public: 
  snapShotEventClass() {planeActor=NULL; planeAxis=0;k=0;};	
	
	void SetRenWin(vtkRenderWindow *rWin) {renWin=rWin;};
  void SetPlaneActor( vtkImageActor *pA, int pAxis){planeActor=pA;planeAxis=pAxis;};
	void SetPollhemusAssembly (vtkAssembly  *pa) {PollhemusAssembly=pa; }
private:
  int k;
 vtkRenderWindow *renWin;
  vtkImageActor *planeActor;
 int planeAxis;
	vtkAssembly  *PollhemusAssembly; 
};























class myEventClass : public vtkCommand
{
	
	
	
	virtual void Execute	( 	vtkObject * 	caller, unsigned long 	eventId, void * 	callData) 	
	{
		
		vtkRenderWindowInteractor *iren = 
		static_cast<vtkRenderWindowInteractor*>(caller);
		int keyCode=iren->GetKeyCode(	);
		cout << "Key:"  << keyCode<< endl;	

		
		cout << "Event ID:" << eventId << endl;
		
		
		switch (eventId)
		{
			case LeftButtonPressEvent  : cout << "RightButtonPressEvent" ;z++;cout << "Z=" << z << endl;break;
			case RightButtonPressEvent : cout << "LeftButtonPressEvent";z--; cout << "Z=" << z << endl;break;
			case MiddleButtonPressEvent: 
				cout << "MiddleButtonPressEvent" << endl;
				
				
				if (dir==0) propsToChange->SetOpacity(0.5);
				if (dir==1) propsToChange->SetOpacity(1.0);
				if (dir==2) propsToChange->SetOpacity(0.0);
				dir++;
				if (dir>2) dir=0;
				
				
				break;
				
		};
		
		
		
		int max=ImageActor->GetWholeZMax	( );
		int min=ImageActor->GetWholeZMin	( );
		
		
		
		
		if (z>max ) {z=max;}
		if (z<min) {z=min;}
		
		ImageActor->SetZSlice (z);
		
		cout << "Current z Slice:" << z << endl;
	};
	
public: 
	myEventClass() {
		z=0;
		dir=0;
	}	
	
  void SetImageActor(vtkImageActor *iA, int a) {ImageActor=iA;};
	void SetPropsToChange (vtkProperty* props) {propsToChange=props;}
	void SetZ (int lz) {z=lz;};
	
private:
	vtkImageActor *ImageActor;
	vtkProperty* propsToChange;
	int z;
	int dir;
};





vtkImageData* GetVTKImageData(NIFTIFloatImage* T1Image)
{
  int sx=T1Image->sx;
  int sy=T1Image->sy;
  int sz=T1Image->sz;
  double dx=T1Image->dx;
  double dy=T1Image->dy;
  double dz=T1Image->dz;
  float max=T1Image->Max();
 
  
  float ox,oy,oz;
  T1Image->ConvertIJKtoXYZ(0, 0, 0, ox, oy, oz);



  unsigned char *Udata= new unsigned char[sx*sy*sz];
  
//ReRender to get Image Orthogonal to VTK Cord System  
 for (int z=0;z<sz;z++)
 for (int y=0;y<sy;y++)
 for (int x=0;x<sx;x++)
   {
     float X=ox+x*dx;
     float Y=oy+y*dy;
     float Z=oz+z*dz;
     int i,j,k;
     T1Image->ConvertXYZtoIJK(X, Y, Z, i,j,k);
     float val=T1Image->GetVoxel(i,j,k)/max*255;
     
     int pos=x+sx*y+sx*sy*z;
     Udata[pos]=  (unsigned char)  val;
     
   };


    


//Nifti Data
  int i,j,k;
  i=0;j=0;k=0;
  float x,y,z;
  	T1Image->ConvertIJKtoXYZ(i, j, k, x, y, z);
	//X1
 float x1,y1,z1;T1Image->ConvertIJKtoXYZ(1, 0, 0, x1, y1, z1);
	//Y1
 float x2,y2,z2;T1Image->ConvertIJKtoXYZ(0, 1, 0, x2, y2, z2);
	//Z1
 float x3,y3,z3;T1Image->ConvertIJKtoXYZ(0, 0, 1, x3, y3, z3);


 cout << "X Dir:" << x1-x << "  " << y1-y << "  " << z1-z << endl;
 cout << "Y Dir:" << x2-x << "  " << y2-y << "  " << z2-z << endl;
 cout << "Z Dir:" << x3-x << "  " << y3-y << "  " << z3-z << endl;



	vtkUnsignedCharArray *array=vtkUnsignedCharArray::New();
	array->SetArray(Udata, sx*sy*sz,1 );
	
	vtkImageData *imageData=vtkImageData::New();
	(imageData->GetPointData())->SetScalars(array);
	imageData->SetDimensions (sx, sy, sz);
	imageData->SetSpacing	(	dx 	, dy 	, dz);	
	imageData->SetScalarType(VTK_UNSIGNED_CHAR);
	imageData->SetOrigin(x,y,z);


  
   
	



   return imageData;

}







int confmode(char *FileName)
{
  int planeAxis=0;
  vtkImageActor *planeActor=NULL;
  string line;
  cout << "Use File:" << FileName << endl;
   ifstream VTK_File (FileName);
 if (!VTK_File.is_open())
   {
     cout << "Error reading File exit!" << endl;
     exit (1);
   };
  
 vtkRenderer *ren1 = vtkRenderer::New();
 
 while ( VTK_File.good() )
    {
      getline (VTK_File,line);
      //kind FileName r g b opacity
      char kind[100];
      char FileName[1024];
      float r,g,b,op;
      int nrRead=sscanf (line.c_str(),"%s %s %f %f %f %f",kind,FileName, &r, &g, &b, &op);
    if (nrRead==6)
      {

	if (strcmp (kind,"nifti_mask")==0)
	  {
	    std::cout << "Load:" << FileName << " as " << kind << " with setting " << r << " " << g << " " << b << " op: " << op << std::endl;
	  NIFTIIntImage* Mask1Image= new NIFTIIntImage();
	  Mask1Image->LoadNiftiImage(FileName);
	  vtkPolyData* Mask1PolyData=GetPolyDataForMaskWithThresholdAndColor(Mask1Image, 0.5, 255.0*r, 255.0*g, 255.0*b);
	  vtkActor * Mask1Actor = GetGlyphActorForPolyData(Mask1PolyData);
	  ren1->AddActor(Mask1Actor);
	  };






	if (strcmp (kind,"smooth_nifti_mask")==0)
	  {
	    std::cout << "Load:" << FileName << " as " << kind << " with setting " << r << " " << g << " " << b << " op: " << op << std::endl;
	  NIFTIIntImage* Mask1Image= new NIFTIIntImage();
	  Mask1Image->LoadNiftiImage(FileName);
	  vtkPolyData* Mask1PolyData=GetPolyDataForMaskWithThresholdAndColor(Mask1Image, 0.5, 255.0*r, 255.0*g, 255.0*b);
	  vtkActor * Mask1Actor =GetGlyphActorWithDelaunyForPolyData(Mask1PolyData,1);
	  vtkProperty *ControlProps=vtkProperty::New(); 
	 ControlProps->SetColor(r,g,b);
	ControlProps->SetAmbientColor(r,g,b);
	ControlProps->SetDiffuseColor(r,g,b);
	ControlProps->SetSpecularColor(r,g,b);
	
	ControlProps->SetOpacity(op);
	 

	  Mask1Actor->SetProperty(ControlProps);



ren1->AddActor(Mask1Actor);
	  };

	if (strcmp (kind,"surface_nifti_mask")==0)
	  {
	    std::cout << "Load:" << FileName << " as " << kind << " with setting " << r << " " << g << " " << b << " op: " << op << std::endl;
	  NIFTIIntImage* Mask1Image= new NIFTIIntImage();
	  Mask1Image->LoadNiftiImage(FileName);
	  vtkPolyData* Mask1PolyData=GetPolyDataForMaskWithThresholdAndColor(Mask1Image, 0.5, 255.0*r, 255.0*g, 255.0*b);
	  vtkActor * Mask1Actor =GetGlyphActorWithDelaunyForPolyData(Mask1PolyData,0);
	  vtkProperty *ControlProps=vtkProperty::New(); 
	 ControlProps->SetColor(r,g,b);
	ControlProps->SetAmbientColor(r,g,b);
	ControlProps->SetDiffuseColor(r,g,b);
	ControlProps->SetSpecularColor(r,g,b);
	
	ControlProps->SetOpacity(op);
	 

	  Mask1Actor->SetProperty(ControlProps);



ren1->AddActor(Mask1Actor);
	  };


	if (strcmp (kind,"nifti_T1")==0)
		  {
			  std::cout << "Load:" << FileName << " as " << kind << " with setting Plane:" << r << " Axis " << g << " " << b << " op: " << op << std::endl;
			  NIFTIFloatImage* T1Image= new NIFTIFloatImage();
			  T1Image->LoadNiftiImage(FileName);
			  T1Image->PrintMinMaxNrNonZero();
			  vtkImageActor *ImageActor = vtkImageActor::New();
			  vtkImageData *vtkT1Image=GetVTKImageData(T1Image);
			  ImageActor->SetInput (vtkT1Image);
			  int startZ=(T1Image->sz)/2;
			  int ex1,ex2,ey1,ey2,ez1,ez2;
			  
			  
			  vtkT1Image-> GetExtent (ex1,ex2,ey1,ey2,ez1,ez2); 
			  planeAxis=(int) r;
			  int middle;
			  switch (planeAxis)
			    {
			    case 1:
			      middle=(ex1+ex2)/2;
			      ex1=middle;
			      ex2=middle;
			      break;
			    case 2:
			      middle=(ey1+ey2)/2;
			      ey1=middle;
			      ey2=middle;
			      break;
			    case 3:
			      middle=(ez1+ez2)/2;
			      ez1=middle;
			      ez2=middle;
			      break;
			    default:
			      middle=(ez1+ez2)/2;
			      ez1=middle;
			      ez2=middle;
			      break;
			      


			    };
			  planeActor=ImageActor;
			  
			  ImageActor ->SetDisplayExtent(ex1,ex2, ey1,ey2, ez1,ez2);
			  //ImageActor->SetZSlice (startZ);	
			  ren1->AddActor(ImageActor);
			 
		  }






	 
	if (strcmp (kind,"nifti_tmap")==0)
		  {
			  std::cout << "Load:" << FileName << " as " << kind << " with setting " << r << " " << g << " " << b << " op: " << op << std::endl;
			  NIFTIFloatImage* TMapImage= new NIFTIFloatImage();
			  TMapImage->LoadNiftiImage(FileName);
			  TMapImage->PrintMinMaxNrNonZero();
			  float Threshold=op*TMapImage->Max();
			  cout << "Threshold:" << Threshold << endl;
			  vtkPolyData* TMapPolyData=GetPolyDataForFloatImageWithThresholdAndColor(TMapImage, Threshold, 255.0*r, 255.0*g, 255.0*b);
			  
			  vtkActor * TmapActor = GetGlyphActorForPolyData(TMapPolyData);
			  ren1->AddActor(TmapActor);
		  }	  
		  
	
	if (strcmp (kind,"nifti_tmap_abs")==0)
		  {
			  std::cout << "Load:" << FileName << " as " << kind << " with setting " << r << " " << g << " " << b << " op: " << op << std::endl;
			  NIFTIFloatImage* TMapImage= new NIFTIFloatImage();
			  TMapImage->LoadNiftiImage(FileName);
			  TMapImage->PrintMinMaxNrNonZero();
			  float Threshold=op;
			  cout << "Threshold:" << Threshold << endl;
			  vtkPolyData* TMapPolyData=GetPolyDataForFloatImageWithThresholdAndColor(TMapImage, Threshold, 255.0*r, 255.0*g, 255.0*b);
			  
			  vtkActor * TmapActor = GetGlyphActorForPolyData(TMapPolyData);
			  ren1->AddActor(TmapActor);
		  }






	  
		  
	if (strcmp (kind,"vtk_polydata")==0) 
	  {
	    std::cout << "Load:" << FileName<< " as " << kind << "with setting " << r << " " << g << " " << b << " op: " << op << std::endl;
	    vtkProperty* ControlProps=vtkProperty::New();
	    ControlProps->SetColor(r,g,b);
   	    ControlProps->SetOpacity(op); 
	    
	    vtkActor *DTIThalamusActor=GetActorForPolyDataFileName(FileName);
	    DTIThalamusActor-> SetProperty (ControlProps);
	    ren1->AddActor(DTIThalamusActor);

	  }



	if (strcmp (kind,"sphere_data")==0) 
	  {
	    std::cout << "Load:" << FileName<< " as " << kind << "with setting " << r << " " << g << " " << b << " op: " << op << std::endl;
	    vtkProperty* ControlProps=vtkProperty::New();
	   
	    list<vtkActor*> assembly=ListSpehereActorsForXYZFile(FileName, r, g, b );
	    for (list<vtkActor*>::iterator it=assembly.begin();it!=assembly.end();it++)
	      ren1->AddActor(*it);
	  
	    cout << "Assembly complete" << endl;
	  }















	if (strcmp (kind,"vtk_smooth_polydata")==0) 
	  {
	    std::cout << "Load:" << FileName<< " as " << kind << "with setting " << r << " " << g << " " << b << " op: " << op << std::endl;
	    vtkProperty* ControlProps=vtkProperty::New();
	    ControlProps->SetColor(r,g,b);
   	    ControlProps->SetOpacity(op); 
	    
	    vtkActor *DTIThalamusActor=GetActorForSmoothPolyDataFileName(FileName);
	    DTIThalamusActor-> SetProperty (ControlProps);
	    ren1->AddActor(DTIThalamusActor);

	  }










	  
      }

    };


//Set Up Vis

 	cout << "Set UP Rendering and Visualisation" << endl;

	vtkRenderWindow *renWin = vtkRenderWindow::New();
	

	char cCurrentPath[FILENAME_MAX];
	getcwd(cCurrentPath, sizeof(cCurrentPath));
	renWin->SetWindowName(cCurrentPath);
	ren1->SetBackground(1,1,1);
renWin->AddRenderer(ren1);
	
	renWin->SetSize(1200, 1200);
	
	vtkRenderWindowInteractor *iren = vtkRenderWindowInteractor::New();
	vtkInteractorStyleTrackballCamera *interactStyle= vtkInteractorStyleTrackballCamera::New();
	
	interactStyle->SetInteractor(iren);
	iren->SetInteractorStyle( interactStyle);
	iren->SetRenderWindow(renWin);

	renWin->Render();
	snapShotEventClass myEvent;
	if (planeActor!=NULL)
	  myEvent.SetPlaneActor(planeActor, planeAxis);
	
	myEvent.SetRenWin(renWin);


	unsigned long eventNr1=iren->AddObserver("LeftButtonPressEvent",&myEvent);
	unsigned long eventNr2=iren->AddObserver("RightButtonPressEvent",&myEvent);
	unsigned long eventNr3=iren->AddObserver("MiddleButtonPressEvent",&myEvent);



	
	// This starts the event loop and as a side effect causes an initial render.
	iren->Start();


	cout << "Done with rendering quit for now." << endl;
	
	ren1->Delete();
	renWin->Delete();
	iren->Delete();


  return 0;
}






vtkActor* GetHeadSurfaceActor(NIFTIFloatImage* T1Image)
{

  vtkImageData* T1ImageData=GetVTKImageData(T1Image);
  vtkSmartPointer<vtkContourFilter> skinExtractor =vtkSmartPointer<vtkContourFilter>::New();
  skinExtractor->SetInput(T1ImageData);
  skinExtractor->SetValue(0, 80);

  vtkSmartPointer<vtkPolyDataNormals> skinNormals =
  vtkSmartPointer<vtkPolyDataNormals>::New();
  skinNormals->SetInputConnection(skinExtractor->GetOutputPort());
  //skinNormals->SetFeatureAngle(60.0);

  vtkSmartPointer<vtkPolyDataMapper> skinMapper =vtkSmartPointer<vtkPolyDataMapper>::New();
  //skinMapper->SetInputConnection(skinNormals->GetOutputPort());
 skinMapper->SetInputConnection(skinExtractor->GetOutputPort());



  skinMapper->ScalarVisibilityOff();
  vtkActor* skin = vtkActor::New();
 skin->SetMapper(skinMapper);

 vtkProperty* skinProps=vtkProperty::New();
	skinProps->SetColor(1,1,1);
	skinProps->SetOpacity(0.3);
	skin-> SetProperty (skinProps);



 return skin;
};









NIFTIFloatImage* T1Image;

vector<float> Nasion(3);
int foundNasion=0;
vector<float> LOhr(3);
int foundLOhr=0;	
vector<float> ROhr(3);
int foundROhr;	
		
list<vector<float> > ContourPoints;
list<string> ContourName;



vtkRenderWindow *GlobalRenWin;
vtkActor* GlobalSkinSurfaceActor;
vtkAssembly  *GlobalPollhemusAssembly; 
	float translationFactor=1.0;
	float rotationFactor=5.0;
	float scaleFactor=1.1;


char *GlobalCTFMRName;

char *GlobalHeadModellFileName;


vector<float> Apply44Matrix(vector<float> in, vtkSmartPointer<vtkMatrix4x4> m )
{
  vector <float> solution(3);
  for (int i=0;i<3;i++)
	solution[i]= m->Element[i][0]*in[0]+m->Element[i][1]*in[1]+m->Element[i][2]*in[2]+m->Element[i][3];
  return solution;

};

int ConvertXYZtoIJKAndTransferToCTFCords(NIFTIFloatImage* T1Imag,   vector<float> vec, int &i, int &j, int &k)
{
  int ti,tj,tk;
  T1Image->ConvertXYZtoIJK(vec[0],vec[1],vec[2], ti, tj, tk);
  int sx2=T1Imag->sx/2;
  int sy2=T1Imag->sy/2;
  int sz2=T1Imag->sz/2;
    
  i=ti-sx2+(256/2);
  j=-1*(tj-sy2)+(256/2);
  k=-1*(tk-sz2)+(25672);

};



void WriteCTFHeadModellFile(vtkSmartPointer<vtkMatrix4x4> m)
{
/* Template 


// *************************************
// 	CTF Head Model:Dipole Parameter File 
// *************************************

// Codes:
// dipole colour: 
//   YELLOW = 0, GREEN = 1, RED = 2, CYAN = 3,
// 	 CYAN = 3, MAGENTA = 4, WHITE = 5, BLACK = 6 
// dipole shape: 
//   FILLED_CIRCLE = 0, FILLED_SQUARE = 1, FILLED_TRIANGLE = 2,
//   HOLLOW_CIRCLE = 3, HOLLOW_SQUARE = 4, HOLLOW_TRIANGLE = 5
// display flags:
//   true = 1, false = 0
// position/moment/orientation constraint flags: 
//   FREE = 0,  FIXED = 1, RANGED = 2,  RADIAL = 3, TANGENTIAL = 4
//   CO-LOCATED = 5, MIRROR SYMMETRIC = 6, ORTHOGONAL_TO_DIPOLE = 7 

File_Info
{
	VERSION:		CTF_HEAD_MODEL_FILE_VERSION_6.0
	DATE:			24-Jul-2012 11:29
	PATIENT:		WN_
	STATUS:		
}

Model
{
	MODEL_TYPE:		MEG_ONLY
	MRI_FILE:		/data1/ppbroser/20120723/WN.mri
}



Voxel_Resolution
{
	// Resolution in mm per voxel
	SAGITTAL:	1.00000000
	CORONAL:	1.00000000
	AXIAL:	1.00000000

}

MRI_Fid_Points
{
	// Fid. Pts	Sag	Cor	Axi
	NASION:		125	42	124
	LEFT_EAR:	58	117	139
	RIGHT_EAR:	192	110	146

}

Marker_Data
{
	// Marker locations in cm
	// X		Y		Z
	1:	8.139	-0.111	6.125
	2:	4.849	0.146	10.170
	3:	-1.365	0.295	12.497
	4:	-6.376	0.180	10.698
	5:	-8.834	-0.068	6.797
	6:	4.344	-5.772	2.191
	7:	5.797	-3.919	7.699
	8:	5.973	3.310	7.918
	9:	4.545	5.654	2.240
	10:	-0.783	-7.259	4.029
	11:	0.645	-5.611	9.454
	12:	1.296	-1.958	11.743
	13:	1.296	3.232	11.413
	14:	0.594	6.253	8.504
	15:	-0.783	7.312	3.101
	16:	-5.602	-6.002	4.888
	17:	-4.275	-4.678	9.945
	18:	-3.749	-1.854	11.802
	19:	-3.799	4.720	11.190
	20:	-4.425	6.563	8.647
	21:	-5.577	6.878	4.165
}



*/
FILE *registrationFile;
registrationFile=fopen(GlobalHeadModellFileName,"w");
if (   registrationFile==NULL)
  {
    printf("Failed to open file!\n");
    return;
  };


	  


fprintf(registrationFile,"File_Info\n{\n VERSION:		CTF_HEAD_MODEL_FILE_VERSION_6.0\n");
fprintf(registrationFile,"      DATE:	     24-Jul-2012 11:29\n");
fprintf(registrationFile,"	PATIENT:     WN_\n");
fprintf(registrationFile,"	STATUS:		\n");
fprintf(registrationFile,"}\n\n");

fprintf(registrationFile,"Model\n");
fprintf(registrationFile,"{\n");
fprintf(registrationFile,"	MODEL_TYPE:		MEG_ONLY\n");
 fprintf(registrationFile,"	MRI_FILE:		%s\n",GlobalCTFMRName );
fprintf(registrationFile,"}\n\n");

fprintf(registrationFile,"Voxel_Resolution\n");
fprintf(registrationFile,"{\n");
//fprintf(registrationFile,"	Resolution in mm per voxel\n");
 fprintf(registrationFile,"      SAGITTAL: %f\n",T1Image->dx);
fprintf(registrationFile,"      CORONAL: %f\n",T1Image->dy);
 fprintf(registrationFile,"	AXIAL: %f\n",T1Image->dz);
	fprintf(registrationFile,"\n");
fprintf(registrationFile,"}\n\n");




fprintf(registrationFile,"MRI_Fid_Points\n");
fprintf(registrationFile,"{\n");
	// Fid. Pts	Sag	Cor	Axi
 
 vector<float> NasionT=Apply44Matrix(Nasion, m );
 vector<float> LOhrT=Apply44Matrix(LOhr, m );
 vector<float> ROhrT=Apply44Matrix(ROhr, m );




int i,j,k;
// T1Image->ConvertXYZtoIJK(NasionT[1],NasionT[0],NasionT[2], i, j, k);
 
 ConvertXYZtoIJKAndTransferToCTFCords( T1Image,NasionT, i, j, k); 
fprintf(registrationFile,"	NASION:		%d	%d	%d\n",i,j,k );

ConvertXYZtoIJKAndTransferToCTFCords( T1Image,LOhrT, i, j, k);
//T1Image->ConvertXYZtoIJK(LOhrT[1],LOhrT[0],LOhrT[2], i, j, k);
fprintf(registrationFile,"	LEFT_EAR:	%d	%d	%d\n",i,j,k);

ConvertXYZtoIJKAndTransferToCTFCords( T1Image,ROhrT, i, j, k);
//T1Image->ConvertXYZtoIJK(ROhrT[1],ROhrT[0],ROhrT[2], i, j, k);
fprintf(registrationFile,"	RIGHT_EAR:	%d	%d	%d\n",i,j,k);

fprintf(registrationFile,"}\n");

fprintf(registrationFile,"Marker_Data\n");
fprintf(registrationFile,"{\n");
	// Marker locations in cm
	// X		Y		Z
 int counter=1;
 for (list<vector<float> >::iterator it=ContourPoints.begin();it!=ContourPoints.end();++it)
   { 
     vector<float> TransIt=Apply44Matrix((*it), m );
     fprintf(registrationFile,"	%d:	%f      %f      %f\n",counter, TransIt[1], TransIt[0], TransIt[2]);
     counter++;
   };
	fprintf(registrationFile,"}\n");


fclose( registrationFile);
};














void KeypressCallbackFunction ( vtkObject* caller, long unsigned int vtkNotUsed(eventId), void* vtkNotUsed(clientData), void* vtkNotUsed(callData) )
{
	std::cout << "Keypress callback" << std::endl;
	
	vtkRenderWindowInteractor *iren = 
    static_cast<vtkRenderWindowInteractor*>(caller);
	char  key_pressed=iren->GetKeyCode();
	




	if (strcmp(iren->GetKeySym(),"Down")==0)
	  {
	    GlobalPollhemusAssembly->AddPosition(0, translationFactor,0);
	  };
	if (strcmp(iren->GetKeySym(),"Up")==0)
	  {
	    GlobalPollhemusAssembly->AddPosition(0,-1* translationFactor,0);
	    
	  };
	if (strcmp(iren->GetKeySym(),"Left")==0)
	  {
	     GlobalPollhemusAssembly->AddPosition(1* translationFactor,0,0);
	  };

	if (strcmp(iren->GetKeySym(),"Right")==0)
	  {
	     GlobalPollhemusAssembly->AddPosition(-1* translationFactor,0,0);
	  };

	if (strcmp(iren->GetKeySym(),"Prior")==0)
	  {
	     GlobalPollhemusAssembly->AddPosition(0,0,1* translationFactor);
	  };

	if (strcmp(iren->GetKeySym(),"Next")==0)
	  {
	     GlobalPollhemusAssembly->AddPosition(0,0,-1* translationFactor);
	  };





	double *scaleP;
	double scale;
	vtkSmartPointer<vtkMatrix4x4> m = vtkSmartPointer<vtkMatrix4x4>::New();
	vtkProperty* skinProps=GlobalSkinSurfaceActor->GetProperty();
	switch (key_pressed)
	  {
	  case '-':
	   std::cout << "- Scale down " << std::endl; 
	   scaleP=GlobalPollhemusAssembly->GetScale();
	   scale=(scaleP[0])/scaleFactor;
	   GlobalPollhemusAssembly->SetScale(scale);
	   break;
	  case '+':
	   std::cout << "+ Scale Up: " << std::endl; 
	   scaleP=GlobalPollhemusAssembly->GetScale();
	   scale=(scaleP[0])*scaleFactor; 
	   GlobalPollhemusAssembly->SetScale(scale);
	   break;

	  case 'x':
	   GlobalPollhemusAssembly->RotateX(rotationFactor);break;
	  case 'X':
	   GlobalPollhemusAssembly->RotateX(-1*rotationFactor);break;  
	  case 'y':
	    GlobalPollhemusAssembly->RotateY(rotationFactor);break;
	   case 'Y':
	    GlobalPollhemusAssembly->RotateY(-1*rotationFactor);break;
	  
	  case 'z':
	    GlobalPollhemusAssembly->RotateZ(rotationFactor);break;
	   case 'Z':
	    GlobalPollhemusAssembly->RotateZ(-1*rotationFactor);break;
	   
	  case 's':
	    	translationFactor=0.1;
		rotationFactor=0.5;
		scaleFactor=1.01;
		break;


	  case 'c':
	    	translationFactor=1.0;
		rotationFactor=5.0;
		scaleFactor=1.1;
		break;

	  case 'm' :
	GlobalPollhemusAssembly->GetMatrix(m);
	for (int i=0;i<4;i++)
	cout << m->Element[i][0] << " " << m->Element[i][1] << " " << m->Element[i][2] << " " << m->Element[i][3] << " " << endl;
	 std::cout << "Matrix: " << endl << *m << std::endl;	
	 break;


	  case 'h':
	   GlobalSkinSurfaceActor->SetVisibility(0);
	   break;
	 
	  case 'H':
	   GlobalSkinSurfaceActor->SetVisibility(1);
	   break;



	  case 'w':
	    GlobalPollhemusAssembly->GetMatrix(m);
	     //write file command 
	    WriteCTFHeadModellFile(m);




	     break;

	   
















	  };



	std::cout << "Pressed: " << iren->GetKeySym() << std::endl;


	











	GlobalRenWin->Render();


}



int main(int argc, char **argv)
{	
	if (argc<5)
	{
		cout << "Usage InteractiveCoregister Polhemus.xyz T1.nii.gz AbsPathTo/MRImageCTF.mri HeadModelFile.hdm" << endl;
		cout << "Rotate x,X, y, Y, z, Z" << endl;
		cout << "Tranlate using arrow keys and Page up down (z)" << endl;
		cout << " Scale by +,-" << endl;
		cout << " Hide show head surface by pressing h, H" << endl;
		cout << " Press M to get Matrix" << endl;
		cout << " Press w to write HeadDefinition file\n";

	return 0;
	};

	vtkRenderer *ren1 = vtkRenderer::New();
	
  	vtkAssembly  *PollhemusAssembly = vtkAssembly::New();
	
	char *PolhemusFileName=argv[1];
	char *T1FileName=argv[2];
	GlobalCTFMRName=argv[3];
	GlobalHeadModellFileName=argv[4];
	int planeAxis=0;
	vtkImageActor *planeActor=NULL;


		string line;
		cout << "Use File:" << PolhemusFileName << endl;
		ifstream Polhemus_File (PolhemusFileName);
		if (!Polhemus_File.is_open())
		{
			cout << "Error reading File exit!" << endl;
			exit (1);
		};
		
		
	

		while ( Polhemus_File.good() )
		{
			getline (Polhemus_File,line);
			//kind FileName r g b opacity
			char kind[100];
			char FileName[1024];
			float cx, cy, cz;
			int nrRead=sscanf (line.c_str(),"%s %f %f %f",kind, &cx, &cy, &cz);
			
			float SphereRadius=0.2;
			if (strcmp (kind,"R.Ohr")==0)
			{
				std::cout << "Rechtes Ohr "<< kind << " with setting " << cx << " " << cy << " " << cz  << std::endl;
				foundROhr=1;
				ROhr[0]=cx;ROhr[1]=cy;ROhr[2]=cz;
				vtkActor* single=SphereActorForPositionAndColorAndRadius(cx,cy,cz,0,1,0,SphereRadius);
				PollhemusAssembly->AddPart(single);
				continue;
			};
			if (strcmp (kind,"L.Ohr")==0)
			{
				std::cout << "Linkes Ohr:" << kind << " with setting " << cx << " " << cy << " " << cz  << std::endl;
				foundLOhr=1;
				LOhr[0]=cx;LOhr[1]=cy;LOhr[2]=cz;
				vtkActor* single=SphereActorForPositionAndColorAndRadius(cx,cy,cz,1,0,0,SphereRadius);
				PollhemusAssembly->AddPart(single);
				continue;
			};
			if (strcmp (kind,"Nasion")==0)
			{
				std::cout << "Nasion:" << kind << " with setting " << cx << " " << cy << " " << cz  << std::endl;
				foundNasion=1;
				Nasion[0]=cx;Nasion[1]=cy;Nasion[2]=cz;
				vtkActor* single=SphereActorForPositionAndColorAndRadius(cx,cy,cz,0,0,1,SphereRadius);
				PollhemusAssembly->AddPart(single);
				continue;
			};
			
			
			std::cout << kind << " with setting " << cx << " " << cy << " " << cz  << std::endl;
					
			vector<float> temp(3);
			temp[0]=cx;temp[1]=cy;temp[2]=cz;
			ContourPoints.push_back(temp);
			ContourName.push_back(string(kind));
			vtkActor* single=SphereActorForPositionAndColorAndRadius(cx,cy,cz,1,1,1,SphereRadius);
			
			PollhemusAssembly->AddPart(single);
			
			
			
		};
	
		if (foundNasion*foundLOhr*foundROhr==0)
		{
			cout << "Missing Nasion or ROhr or Left Ohr Quit!" << endl;
			return 1;
		}
	
	PollhemusAssembly->SetScale(10);
	GlobalPollhemusAssembly= PollhemusAssembly;
	ren1->AddActor(PollhemusAssembly);
	
	//assembly.SetOrigin(5, 10, 15)
	//assembly.AddPosition(5, 0, 0)
	//assembly.RotateX(15)
	
	
	
		//Polhemus Tags
		// Contxx
		//L.Ohr        -0.10    6.19   -0.00
		//R.Ohr         0.10   -6.19    0.00
		//Nasion        8.21    0.00    0.00
		//Set Up Vis
	
	
	///////////// Load T1
	
	
	T1Image= new NIFTIFloatImage();
	T1Image->LoadNiftiImage(T1FileName);
	T1Image->PrintMinMaxNrNonZero();
	vtkImageActor *ImageActor = vtkImageActor::New();
	vtkImageData *vtkT1Image=GetVTKImageData(T1Image);
	ImageActor->SetInput (vtkT1Image);
	int startZ=(T1Image->sz)/2;
	int ex1,ex2,ey1,ey2,ez1,ez2;
	
	
	vtkT1Image-> GetExtent (ex1,ex2,ey1,ey2,ez1,ez2); 
	planeAxis=0;
	int middle;
	switch (planeAxis)
	{
		case 1:
			middle=(ex1+ex2)/2;
			ex1=middle;
			ex2=middle;
			break;
		case 2:
			middle=(ey1+ey2)/2;
			ey1=middle;
			ey2=middle;
			break;
		case 3:
			middle=(ez1+ez2)/2;
			ez1=middle;
			ez2=middle;
			break;
		default:
			middle=(ez1+ez2)/2;
			ez1=middle;
			ez2=middle;
			break;
			
			
			
	};
	planeActor=ImageActor;
	
	ImageActor ->SetDisplayExtent(ex1,ex2, ey1,ey2, ez1,ez2);
	ImageActor ->PickableOff ();
	//ImageActor -> SetDragable(0);
	//ImageActor->SetZSlice (startZ);	
	ren1->AddActor(ImageActor);
	
	
	
	
	vtkActor* SkinSurfaceActor=GetHeadSurfaceActor(T1Image);
	ren1->AddActor(SkinSurfaceActor);
	GlobalSkinSurfaceActor=SkinSurfaceActor;
	
	
	
	
	
	
	
	
	
	
	////////////
	
	
	cout << "Set UP Rendering and Visualisation" << endl;
	
	vtkRenderWindow *renWin = vtkRenderWindow::New();
	GlobalRenWin=renWin;
	
	char cCurrentPath[FILENAME_MAX];
	getcwd(cCurrentPath, sizeof(cCurrentPath));
	renWin->SetWindowName(cCurrentPath);
	ren1->SetBackground(1,1,1);
	renWin->AddRenderer(ren1);
	
	renWin->SetSize(1200, 1200);
	
	vtkRenderWindowInteractor *iren = vtkRenderWindowInteractor::New();
	//vtkGenericRenderWindowInteractor *iren =vtkGenericRenderWindowInteractor::New();
	
	vtkInteractorStyleTrackballCamera *interactStyle= vtkInteractorStyleTrackballCamera::New();
	
	vtkInteractorStyleSwitch *switchInteractStyle = vtkInteractorStyleSwitch::New();
	
	
	interactStyle->SetInteractor(iren);
	iren->SetInteractorStyle( interactStyle);
//	iren->SetInteractorStyle( switchInteractStyle);
	//switchInteractStyle->	SetCurrentStyleToTrackballActor ();
	
	
	iren->SetRenderWindow(renWin);
	
	renWin->Render();
	snapShotEventClass myEvent;
	if (planeActor!=NULL)
		myEvent.SetPlaneActor(planeActor, planeAxis);
	myEvent. SetPollhemusAssembly (PollhemusAssembly);
	myEvent.SetRenWin(renWin);
	
	
	unsigned long eventNr1=iren->AddObserver("LeftButtonPressEvent",&myEvent);
	unsigned long eventNr2=iren->AddObserver("RightButtonPressEvent",&myEvent);
	unsigned long eventNr3=iren->AddObserver("MiddleButtonPressEvent",&myEvent);
	
	
	
	//Key Events 
	//vtkSmartPointer<vtkCallbackCommand> keypressCallback = vtkSmartPointer<vtkCallbackCommand>::New();
	vtkCallbackCommand* keypressCallback = vtkCallbackCommand::New();
	
	keypressCallback->SetCallback ( KeypressCallbackFunction );
	iren->AddObserver ( vtkCommand::KeyPressEvent, keypressCallback );
	
	
	
	
	
	
	// This starts the event loop and as a side effect causes an initial render.
	iren->Start();
	
	
	cout << "Done with rendering quit for now." << endl;
	
	ren1->Delete();
	renWin->Delete();
	iren->Delete();
	
	
	
	
	
	
	
	
	
	
	
	
	return 0;
}





