/*
 *  Tract Viewer converts a Nifti Image to an unsructed grid 
 *
 */

#include <string>

#include "DataTypes.h"
#include "NIFTIIntImage.h"
#include "NIFTIFloatImage.h"
#include "VTKVisualization.h"
#include "vtkGenericRenderWindowInteractor.h"
#include "vtkInteractorStyleTrackballActor.h"
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <sstream>
#include <cstdio>

#include <vtkCallbackCommand.h>
#include <vtkCommand.h>

#include <iostream>
#include<string>

#include <unistd.h>
#include <vtkWindowToImageFilter.h>
//vtkPNGWriter
#include <vtkInteractorStyleSwitch.h>

#define GetCurrentDir getcwd

#include <vtkMatrix4x4.h>

#include <vtkContourFilter.h>
#include <vtkStripper.h>
#include <vtkFollower.h> 
#include <vtkVectorText.h> 


float Distance(int x, int y, int z, vector<double>  center)
{

  return sqrt ( (x-center[0])*(x-center[0])+(y-center[1])*(y-center[1])+(z-center[2])*(z-center[2]));

}


float Distance(int x, int y, int z, vector<double>  center, float dx, float  dy, float dz)
{

  return sqrt ( dx*dx*(x-center[0])*(x-center[0])+dy*dy*(y-center[1])*(y-center[1])+dz*dz*(z-center[2])*(z-center[2]));

}


int DrawSphere(NIFTIFloatImage *Image, vector<double> center, double radius, float value)
{
	
	int sx=Image->sx;
	int sy=Image->sy;
	int sz=Image->sz;
		
	for(int z=center[2]-2*radius;z<center[2]+2*radius;z++)
		for(int y=center[1]-2*radius;y<center[1]+2*radius;y++)
			for(int x=center[0]-2*radius;x<center[0]+2*radius;x++)
			  if (Distance(x,y,z, center)<radius)  Image->SetVoxel(x, y, z, value);





};





















class snapShotEventClass : public vtkCommand
{
	
	
	
	virtual void Execute	( 	vtkObject * 	caller, unsigned long 	eventId, void * 	callData) 	
	{
		
		vtkRenderWindowInteractor *iren = 
		static_cast<vtkRenderWindowInteractor*>(caller);
		//cout << "Key:"  << keyCode<< endl;	
		if (iren->GetShiftKey())
		{
			
		};		
			
		cout << "Event ID:" << eventId << endl;
		
		
		
		
		
		
		vtkWindowToImageFilter *snapShot=vtkWindowToImageFilter::New	( 	 	);
		snapShot->	SetInput(renWin);
		vtkPNGWriter *wr=vtkPNGWriter::New();
		wr->SetInputConnection(snapShot->GetOutputPort());
		
	
		switch (eventId)
		{
			
			case LeftButtonPressEvent  : 
			  cout << "LeftButtonPressEvent: Switch Plane Event" ;
			  if (planeActor!=NULL)
			    {
			     vtkImageData *data= planeActor->GetInput();
			     int ex1,ex2,ey1,ey2,ez1,ez2;
			     int dex1,dex2,dey1,dey2,dez1,dez2;
			    data-> GetExtent (ex1,ex2,ey1,ey2,ez1,ez2);
			    int extend[6];
			    planeActor -> GetDisplayExtent (extend);
			    dex1=extend[0];dex2=extend[1];dey1=extend[2];dey2=extend[3];
			    dez1=extend[4];dez2=extend[5];


			    if (iren->GetShiftKey())
			      {
				planeAxis++;
				if (planeAxis>3) planeAxis=1;
				int middle;
					switch (planeAxis)
	{
		case 1:
			middle=(ex1+ex2)/2;
			dex1=middle;
			dex2=middle;
			break;
		case 2:
			middle=(ey1+ey2)/2;
			dey1=middle;
			dey2=middle;
			break;
		case 3:
			middle=(ez1+ez2)/2;
			dez1=middle;
			dez2=middle;
			break;
		default:
			middle=(ez1+ez2)/2;
			dez1=middle;
			dez2=middle;
			break;
			
			
			
	};
					     



			      };




		    
			  int middle;
			  switch (planeAxis)
			    {
			    case 1:
			      dex1=dex1+1;
			      dex2=dex2+1;
			      if (dex1>ex2) {dex1=ex1;dex2=ex1;};
			      dey1=ey1;dey2=ey2;dez1=ez1;dez2=ez2;
			      break;
			    case 2:
			      dey1=dey1+1;
			      dey2=dey2+1;
			      if (dey1>ey2) {dey1=ey1;dey2=ey1;};
			      dex1=ex1;dex2=ex2;dez1=ez1;dez2=ez2;
			      break;
			    case 3:
			      dez1=dez1+1;
			      dez2=dez2+1;
			      if (dez1>ez2) {dez1=ez1;dez2=ez1;};
			      dex1=ex1;dex2=ex2;dey1=ey1;dey2=ey2;
			      break;
			    default:
			     dez1=dez1+1;
			      dez2=dez2+1;
			      if (dez1>ez2) {dez1=ez1;dez2=ez1;};
			      dex1=ex1;dex2=ex2;dey1=ey1;dey2=ey2;


			      break;
			      


			    };
					  
			  planeActor ->SetDisplayExtent(dex1,dex2, dey1,dey2, dez1,dez2);
			  break;	
			    };
	
			case MiddleButtonPressEvent: cout << "MiddleButtonPressEvent" << endl;
				char buffer[1024];
				sprintf(buffer,"SnapShot%d.png",k);k++;
				wr->SetFileName( buffer);
				wr->Write();
				;break;
				
				
			case RightButtonPressEvent :
			  cout << "RightButtonPressEvent";

	 
			  if (planeActor!=NULL)
			    {
			     vtkImageData *data= planeActor->GetInput();
			     int ex1,ex2,ey1,ey2,ez1,ez2;
			     int dex1,dex2,dey1,dey2,dez1,dez2;
			    data-> GetExtent (ex1,ex2,ey1,ey2,ez1,ez2);
			    int extend[6];
			    planeActor -> GetDisplayExtent (extend);
			    dex1=extend[0];dex2=extend[1];dey1=extend[2];dey2=extend[3];
			    dez1=extend[4];dez2=extend[5];
		    
			  int middle;
			  switch (planeAxis)
			    {
			    case 1:
			      dex1=dex1-1;
			      dex2=dex2-1;
			      if (dex1<ex1) {dex1=ex1;dex2=ex1;};
			      dey1=ey1;dey2=ey2;dez1=ez1;dez2=ez2;
			      break;
			    case 2:
			      dey1=dey1-1;
			      dey2=dey2-1;
			      if (dey1<ey1) {dey1=ey1;dey2=ey1;};
			      dex1=ex1;dex2=ex2;dez1=ez1;dez2=ez2;
			      break;
			    case 3:
			      dez1=dez1-1;
			      dez2=dez2-1;
			      if (dez1<ez1) {dez1=ez1;dez2=ez1;};
			      dex1=ex1;dex2=ex2;dey1=ey1;dey2=ey2;
			      break;
			    default:
			     dez1=dez1-1;
			      dez2=dez2-1;
			      if (dez1<ez1) {dez1=ez1;dez2=ez1;};
			      dex1=ex1;dex2=ex2;dey1=ey1;dey2=ey2;
			      break;};
				  
			  planeActor ->SetDisplayExtent(dex1,dex2, dey1,dey2, dez1,dez2);
			    }
			  break;
				
		};
		
		
		
	};
	
public: 
  snapShotEventClass() {planeActor=NULL; planeAxis=0;k=0;};	
	
	void SetRenWin(vtkRenderWindow *rWin) {renWin=rWin;};
  void SetPlaneActor( vtkImageActor *pA, int pAxis){planeActor=pA;planeAxis=pAxis;};
	void SetPollhemusAssembly (vtkAssembly  *pa) {PollhemusAssembly=pa; }
private:
  int k;
 vtkRenderWindow *renWin;
  vtkImageActor *planeActor;
 int planeAxis;
	vtkAssembly  *PollhemusAssembly; 
};









#include <vtkStripper.h>
















vtkImageData* GetVTKImageData(NIFTIFloatImage* T1Image)
{
  int sx=T1Image->sx;
  int sy=T1Image->sy;
  int sz=T1Image->sz;
  double dx=T1Image->dx;
  double dy=T1Image->dy;
  double dz=T1Image->dz;
  float max=T1Image->Max();
 
	//Max Determines Contratst set 500
max=500;



  //We could Simplyfy and unify visualisation spacing will always be 1.0mm
  //double dx=1.0;
  //double dy=1.0;
  //double dz=1.0;
  


  float ox,oy,oz;
  T1Image->ConvertIJKtoXYZ(0, 0, 0, ox, oy, oz);



  unsigned char *Udata= new unsigned char[sx*sy*sz];
  
//ReRender to get Image Orthogonal to VTK Cord System  
 for (int z=0;z<sz;z++)
 for (int y=0;y<sy;y++)
 for (int x=0;x<sx;x++)
   {
     float X=ox+x*dx;
     float Y=oy+y*dy;
     float Z=oz+z*dz;
     int i,j,k;
     T1Image->ConvertXYZtoIJK(X, Y, Z, i,j,k);
     float val=0.0;
     if (i>0 && i<sx && j>0 && j<sy && k>0 && k<sz)
       val=T1Image->GetVoxel(i,j,k)/max*255.0;

	

     int pos=x+sx*y+sx*sy*z;
     Udata[pos]=  (unsigned char)  val;
     
   };


    


//Nifti Data
  int i,j,k;
  i=0;j=0;k=0;
  float x,y,z;
  	T1Image->ConvertIJKtoXYZ(i, j, k, x, y, z);
	//X1
 float x1,y1,z1;T1Image->ConvertIJKtoXYZ(1, 0, 0, x1, y1, z1);
	//Y1
 float x2,y2,z2;T1Image->ConvertIJKtoXYZ(0, 1, 0, x2, y2, z2);
	//Z1
 float x3,y3,z3;T1Image->ConvertIJKtoXYZ(0, 0, 1, x3, y3, z3);
cout << "Q Form Code:" << T1Image->nim->qform_code << endl;;
cout << "S Form Code:" << T1Image->nim->sform_code << endl;;
cout << "Pix Dim 1:" <<(T1Image->nim->pixdim[1]) << endl;;
cout << "Pix Dim 2:" <<(T1Image->nim->pixdim[2]) << endl;;
cout << "Pix Dim 3:" <<(T1Image->nim->pixdim[3]) << endl;;
     	

 cout << "X Dir:" << x1-x << "  " << y1-y << "  " << z1-z << endl;
 cout << "Y Dir:" << x2-x << "  " << y2-y << "  " << z2-z << endl;
 cout << "Z Dir:" << x3-x << "  " << y3-y << "  " << z3-z << endl;



	vtkUnsignedCharArray *array=vtkUnsignedCharArray::New();
	array->SetArray(Udata, sx*sy*sz,1 );
	
	vtkImageData *imageData=vtkImageData::New();
	(imageData->GetPointData())->SetScalars(array);
	imageData->SetDimensions (sx, sy, sz);
	imageData->SetSpacing	(	dx 	, dy 	, dz);	
	imageData->SetScalarType(VTK_UNSIGNED_CHAR);
	imageData->SetOrigin(x,y,z);

   return imageData;

}




vtkImageData* GetVTKImageData(NIFTIFloatImage* T1Image, float contrast)
{
  int sx=T1Image->sx;
  int sy=T1Image->sy;
  int sz=T1Image->sz;
  double dx=T1Image->dx;
  double dy=T1Image->dy;
  double dz=T1Image->dz;
  float max=T1Image->Max();
 
	//Max Determines Contratst set 500
if (contrast==0.0){max=T1Image->Max();} else max=contrast;



  //We could Simplyfy and unify visualisation spacing will always be 1.0mm
  //double dx=1.0;
  //double dy=1.0;
  //double dz=1.0;
  


  float ox,oy,oz;
  T1Image->ConvertIJKtoXYZ(0, 0, 0, ox, oy, oz);



  unsigned char *Udata= new unsigned char[sx*sy*sz];
  
//ReRender to get Image Orthogonal to VTK Cord System  
 for (int z=0;z<sz;z++)
 for (int y=0;y<sy;y++)
 for (int x=0;x<sx;x++)
   {
     float X=ox+x*dx;
     float Y=oy+y*dy;
     float Z=oz+z*dz;
     int i,j,k;
     T1Image->ConvertXYZtoIJK(X, Y, Z, i,j,k);
     float val=0.0;
     if (i>0 && i<sx && j>0 && j<sy && k>0 && k<sz)
       val=T1Image->GetVoxel(i,j,k)/max*255.0;

	

     int pos=x+sx*y+sx*sy*z;
     Udata[pos]=  (unsigned char)  val;
     
   };


    


//Nifti Data
  int i,j,k;
  i=0;j=0;k=0;
  float x,y,z;
  	T1Image->ConvertIJKtoXYZ(i, j, k, x, y, z);
	//X1
 float x1,y1,z1;T1Image->ConvertIJKtoXYZ(1, 0, 0, x1, y1, z1);
	//Y1
 float x2,y2,z2;T1Image->ConvertIJKtoXYZ(0, 1, 0, x2, y2, z2);
	//Z1
 float x3,y3,z3;T1Image->ConvertIJKtoXYZ(0, 0, 1, x3, y3, z3);
cout << "Q Form Code:" << T1Image->nim->qform_code << endl;;
cout << "S Form Code:" << T1Image->nim->sform_code << endl;;
cout << "Pix Dim 1:" <<(T1Image->nim->pixdim[1]) << endl;;
cout << "Pix Dim 2:" <<(T1Image->nim->pixdim[2]) << endl;;
cout << "Pix Dim 3:" <<(T1Image->nim->pixdim[3]) << endl;;
     	

 cout << "X Dir:" << x1-x << "  " << y1-y << "  " << z1-z << endl;
 cout << "Y Dir:" << x2-x << "  " << y2-y << "  " << z2-z << endl;
 cout << "Z Dir:" << x3-x << "  " << y3-y << "  " << z3-z << endl;



	vtkUnsignedCharArray *array=vtkUnsignedCharArray::New();
	array->SetArray(Udata, sx*sy*sz,1 );
	
	vtkImageData *imageData=vtkImageData::New();
	(imageData->GetPointData())->SetScalars(array);
	imageData->SetDimensions (sx, sy, sz);
	imageData->SetSpacing	(	dx 	, dy 	, dz);	
	imageData->SetScalarType(VTK_UNSIGNED_CHAR);
	imageData->SetOrigin(x,y,z);

   return imageData;

}










vtkActor* GetHeadSurfaceActor(NIFTIFloatImage* T1Image)
{

  vtkImageData* T1ImageData=GetVTKImageData(T1Image);
  vtkSmartPointer<vtkContourFilter> skinExtractor =vtkSmartPointer<vtkContourFilter>::New();
  skinExtractor->SetInput(T1ImageData);
  skinExtractor->SetValue(0, 40);

  vtkSmartPointer<vtkPolyDataNormals> skinNormals =
  vtkSmartPointer<vtkPolyDataNormals>::New();
  skinNormals->SetInputConnection(skinExtractor->GetOutputPort());
  skinNormals->SetFeatureAngle(60.0);



vtkSmartPointer<vtkStripper> skinStripper =
vtkSmartPointer<vtkStripper>::New();
  skinStripper->SetInputConnection(skinNormals->GetOutputPort());



  vtkSmartPointer<vtkPolyDataMapper> skinMapper =vtkSmartPointer<vtkPolyDataMapper>::New();
  //skinMapper->SetInputConnection(skinNormals->GetOutputPort());
skinMapper->SetInputConnection(skinStripper->GetOutputPort());
 //skinMapper->SetInputConnection(skinExtractor->GetOutputPort());



  skinMapper->ScalarVisibilityOff();
  vtkActor* skin = vtkActor::New();
 skin->SetMapper(skinMapper);

 vtkProperty* skinProps=vtkProperty::New();
	skinProps->SetColor(1,1,1);
	skinProps->SetOpacity(1.0);
	skin-> SetProperty (skinProps);



 return skin;
};









NIFTIFloatImage* T1Image;
string TargetName;


vector<float> Nasion(3);
int foundNasion=0;
vector<float> LOhr(3);
int foundLOhr=0;	
vector<float> ROhr(3);
int foundROhr;	
		
list<vector<float> > ContourPoints;
list<string> ContourName;



vtkRenderWindow *GlobalRenWin;
vtkActor* GlobalSkinSurfaceActor;
vtkAssembly  *GlobalPollhemusAssembly; 
	float translationFactor=1.0;
	float rotationFactor=5.0;
	float scaleFactor=1.1;


char *GlobalCTFMRName;

char *GlobalHeadModellFileName;


vector<float> Apply44Matrix(vector<float> in, vtkSmartPointer<vtkMatrix4x4> m )
{
  vector <float> solution(3);
  for (int i=0;i<3;i++)
	solution[i]= m->Element[i][0]*in[0]+m->Element[i][1]*in[1]+m->Element[i][2]*in[2]+m->Element[i][3];
  return solution;

};

int ConvertXYZtoIJKAndTransferToCTFCords(NIFTIFloatImage* T1Imag,   vector<float> vec, int &i, int &j, int &k)
{
  int ti,tj,tk;
  T1Image->ConvertXYZtoIJK(vec[0],vec[1],vec[2], ti, tj, tk);
  int sx2=T1Imag->sx/2;
  int sy2=T1Imag->sy/2;
  int sz2=T1Imag->sz/2;
    
  i=ti-sx2+(256/2);
  j=-1*(tj-sy2)+(256/2);
  k=-1*(tk-sz2)+(25672);

};


























void KeypressCallbackFunction ( vtkObject* caller, long unsigned int vtkNotUsed(eventId), void* vtkNotUsed(clientData), void* vtkNotUsed(callData) )
{
  std::cout << "Keypress callback"<< std::endl << std::endl;
	
	vtkRenderWindowInteractor *iren = 
    static_cast<vtkRenderWindowInteractor*>(caller);
	char  key_pressed=iren->GetKeyCode();
	




	if (strcmp(iren->GetKeySym(),"Down")==0)
	  {
	   
	  };
	if (strcmp(iren->GetKeySym(),"Up")==0)
	  {
	    
	    
	  };
	if (strcmp(iren->GetKeySym(),"Left")==0)
	  {
	    
	  };

	if (strcmp(iren->GetKeySym(),"Right")==0)
	  {
	    
	  };

	if (strcmp(iren->GetKeySym(),"Prior")==0)
	  {
	    
	  };

	if (strcmp(iren->GetKeySym(),"Next")==0)
	  {
	     
	  };





	double *scaleP;
	double scale;
	vtkSmartPointer<vtkMatrix4x4> m = vtkSmartPointer<vtkMatrix4x4>::New();
	//vtkProperty* skinProps=GlobalSkinSurfaceActor->GetProperty();
	switch (key_pressed)
	  {
	  case '-':
	   std::cout << "- Scale down " << std::endl; 
	break;
	   
	  case 's':
	    	translationFactor=0.1;
		rotationFactor=0.5;
		scaleFactor=1.01;
		break;


	  case 'c':
	    	translationFactor=1.0;
		rotationFactor=5.0;
		scaleFactor=1.1;
		break;

	  case 'm' :
	
	 break;


	  case 'h':
	    if (GlobalSkinSurfaceActor!=NULL) GlobalSkinSurfaceActor->SetVisibility(0);
	   break;
	 
	  case 'H':
	    if (GlobalSkinSurfaceActor!=NULL) GlobalSkinSurfaceActor->SetVisibility(1);
	   break;



	  case 'w':
	   break;


	  case 'p':
  


	    break;











	  };



	std::cout << "Pressed: " << iren->GetKeySym() << std::endl;


	











	GlobalRenWin->Render();


}











vtkAssembly* ListTubeActorsForXYZFile(char *FileName,NIFTIFloatImage * T1Image, vtkRenderer *ren1 )
{

  list<vtkActor*> assembly;
vtkAssembly  *ElAssembly = vtkAssembly::New();
  
string line;
  cout << "Use File:" << FileName << endl;
  ifstream VTK_File (FileName);
  if (!VTK_File.is_open())
   {
     cout << "Error reading File exit!" << endl;
     exit (1);
   };
  
  while ( VTK_File.good() )
    {
      getline (VTK_File,line);
      //kind FileName r g b opacity
      char kind[100];
      char FileName[1024];
      float r,g,b;
	float i,j,k,si,sj,sk;
	float x,y,z,sx,sy,sz;
	char NameC;
	char Name[10];
	

	 int nrRead=sscanf (line.c_str(),"%f %f %f %f %f %f %f %f %f %c", &i, &j, &k, &si, &sj, &sk , &r, &g, &b, &NameC );
	
	
if (nrRead==10)
      {
	T1Image->ConvertIJKtoXYZ(i, j, k, x, y, z);
	T1Image->ConvertIJKtoXYZ(si, sj, sk, sx, sy, sz);
	sprintf(Name, "%c", NameC);

	cout << "Position:" << x << " " << y << " " << z << endl;
	cout << "Name:" << Name << endl;
	vtkActor* single=TubeActorForStartStopPositionAndColor(x, y, z,sx, sy, sz, r, g, b );
	ElAssembly->AddPart(single);
      
	//Caption
	/*
	vtkSmartPointer<vtkFollower> xLabel =  	vtkSmartPointer<vtkFollower>::New();
  	vtkSmartPointer<vtkVectorText> xText = 	vtkSmartPointer<vtkVectorText>::New();
  	vtkSmartPointer<vtkPolyDataMapper> xTextMapper = vtkSmartPointer<vtkPolyDataMapper>::New();
  	xText->SetText( Name );
  	xTextMapper->SetInputConnection( xText->GetOutputPort() );
	xLabel->SetMapper( xTextMapper );
  	xLabel->SetScale( 4 );
  	xLabel->SetCamera(ren1->GetActiveCamera());
	xLabel->SetOrigin(0,0,0);

	xLabel->PickableOff();
  	vtkProperty* ControlProps=vtkProperty::New();
	ControlProps->SetColor(r,g,b);
 	ControlProps->SetOpacity(1.0); 
	xLabel-> SetProperty (ControlProps);
	xLabel->AddPosition(x,y,z);
	ElAssembly->AddPart(xLabel);	
	*/

	vtkVectorText *ElText = 	vtkVectorText::New();
	ElText->SetText( Name );
	vtkPolyDataMapper *ElTextMapper= vtkPolyDataMapper::New();
	ElTextMapper->SetInput(ElText->GetOutput());
	vtkActor *ElActor=vtkActor::New();
	ElActor->SetScale( 6 );	
	ElActor->SetMapper(ElTextMapper);
	ElActor->SetOrientation(90,90,90);
	vtkProperty* ElControlProps=vtkProperty::New();
	ElControlProps->SetColor(r,g,b);
	ElControlProps->SetOpacity(1.0); 
	ElActor-> SetProperty (ElControlProps);
	ElActor->AddPosition(x+5,y+15,z+10);

 	
	ElAssembly->AddPart(ElActor);
	

	ElAssembly->AddPart(SphereActorForPositionAndColorAndRadius(x, y, z, r, g, b, 6 ));
}
else 
	{
	cout << "Wrong Number of Reads:" << nrRead <<" :" << line << cout << endl;	
	};

    };

  return ElAssembly;

}












int main(int argc, char **argv)
{	
	
	vtkRenderer *ren1 = vtkRenderer::New();
	//char *T1FileName=argv[2];
	char T1FileName[100];
	sprintf(T1FileName,"StepperJunus3D_wap.hdr");
	
	char ElFileName[100];
	sprintf(ElFileName,"StepperJunus3D_El.txt");


	TargetName=string(argv[3]);
	char *NotImplemted=new char[100];
	sprintf(NotImplemted,"Empty.txt");
	
	int planeAxis=0;
	vtkImageActor *planeActor=NULL;

	
       vtkActor* Origin=SphereActorForPositionAndColorAndRadius(0,0,0,0.3,0.3,0.8,5);
       ren1->AddActor(Origin);
       vtkActor* Origin1=SphereActorForPositionAndColorAndRadius(100,0,0,1.0,0.3,0.8,5);
       ren1->AddActor(Origin1);




	
	///////////// Load T1
	
	
	T1Image= new NIFTIFloatImage();
	T1Image->LoadNiftiImage(T1FileName);
	string ImageFileName=TargetName+string("int_image");



	T1Image->PrintMinMaxNrNonZero();
	vtkImageActor *ImageActor = vtkImageActor::New();
	vtkImageData *vtkT1Image=GetVTKImageData(T1Image);
	ImageActor->SetInput (vtkT1Image);
	int startZ=(T1Image->sz)/2;
	int ex1,ex2,ey1,ey2,ez1,ez2;
	
	
	vtkT1Image-> GetExtent (ex1,ex2,ey1,ey2,ez1,ez2); 
	



	planeAxis=0;
	int middle;
	switch (planeAxis)
	{
		case 1:
			middle=(ex1+ex2)/2;
			ex1=middle;
			ex2=middle;
			break;
		case 2:
			middle=(ey1+ey2)/2;
			ey1=middle;
			ey2=middle;
			break;
		case 3:
			middle=(ez1+ez2)/2;
			ez1=middle;
			ez2=middle;
			break;
		default:
			middle=(ez1+ez2)/2;
			ez1=middle;
			ez2=middle;
			break;
			
			
			
	};
	planeActor=ImageActor;
	
	ImageActor ->SetDisplayExtent(ex1,ex2, ey1,ey2, ez1,ez2);
	ImageActor ->PickableOff ();
		
	ren1->AddActor(ImageActor);
	
	
	
	int surface=1;
	vtkActor* SkinSurfaceActor=NULL;
	if (surface)
	  {
	    SkinSurfaceActor=GetHeadSurfaceActor(T1Image);
	    ren1->AddActor(SkinSurfaceActor);
	  };
	GlobalSkinSurfaceActor=SkinSurfaceActor;
	
	
	
	//Add Electrodes 
	float x,y,z,sx,sy,sz;
	T1Image->ConvertIJKtoXYZ(123, 187, 126, x, y, z);
	T1Image->ConvertIJKtoXYZ(119, 143, 109, sx, sy, sz);
	
	vtkActor* El1=TubeActorForStartStopPositionAndColor(x, y, z,sx, sy, sz, 1.0, 0, 0 );
	//ren1->AddActor(El1);
	
	//File with actors
	//vtkAssembly* ElectrodeActorList=ListTubeActorsForXYZFile(char *FileName, T1Image );
	

	 

	
	////////////
	
	
	cout << "Set UP Rendering and Visualisation" << endl;
	
	vtkRenderWindow *renWin = vtkRenderWindow::New();
	GlobalRenWin=renWin;
	
	char cCurrentPath[FILENAME_MAX];
	getcwd(cCurrentPath, sizeof(cCurrentPath));
	renWin->SetWindowName(cCurrentPath);
	ren1->SetBackground(1,1,1);
	renWin->AddRenderer(ren1);
	renWin->SetSize(1200, 1200);
	vtkRenderWindowInteractor *iren = vtkRenderWindowInteractor::New();
	vtkInteractorStyleTrackballCamera *interactStyle= vtkInteractorStyleTrackballCamera::New();
	vtkInteractorStyleSwitch *switchInteractStyle = vtkInteractorStyleSwitch::New();
	interactStyle->SetInteractor(iren);
	iren->SetInteractorStyle( interactStyle);

	iren->SetRenderWindow(renWin);
	renWin->Render();
	snapShotEventClass myEvent;
	if (planeActor!=NULL)
		myEvent.SetPlaneActor(planeActor, planeAxis);
	myEvent.SetRenWin(renWin);
	
	
	unsigned long eventNr1=iren->AddObserver("LeftButtonPressEvent",&myEvent);
	unsigned long eventNr2=iren->AddObserver("RightButtonPressEvent",&myEvent);
	unsigned long eventNr3=iren->AddObserver("MiddleButtonPressEvent",&myEvent);
		
	//Key Events 
	vtkCallbackCommand* keypressCallback = vtkCallbackCommand::New();
	keypressCallback->SetCallback ( KeypressCallbackFunction );
	iren->AddObserver ( vtkCommand::KeyPressEvent, keypressCallback );
	
	//Now Add Electodes and Captions 
	
	vtkAssembly* ElectrodeActorList=ListTubeActorsForXYZFile(ElFileName, T1Image, ren1 );
	ren1->AddActor(ElectrodeActorList);

	
	
	
	renWin->Render();
	// This starts the event loop and as a side effect causes an initial render.
	iren->Start();
	
	
	cout << "Done with rendering quit for now." << endl;
	
	ren1->Delete();
	renWin->Delete();
	iren->Delete();
	
	
	
	
	
	
	
	
	
	
	
	
	return 0;
}




























