
#include "NIFTIIntImage.h"





NIFTIIntImage::
~NIFTIIntImage()
{
	//cout << "1" << endl;
	if (nim!=NULL) nifti_image_free(nim);
	//cout << "2" << endl;
	if (ImageData!=NULL) delete [] ImageData;
	//cout << "3" << endl;
	if (Udata!=NULL) delete [] Udata;
cout << "1" << endl;
};





/*
double ColorFrontalCortexLeft[3]={1,0,0};
double ColorMotorCortexLeft[3]={1,0,1};
double ColorOccipitalCortexLeft[3]={0,0,1};
double ColorPosteriorParietalCortexLeft[3]={0,1,0};
double ColorSensoryCortexLeft[3]={0.3,0.3,0.3};
double ColorTemporalCortexLeft[3]={1,1,0};
*/



//DTI Data Management 
template<typename T> unsigned char*  GetScaledData(T* dataPointer, int numberOfDataEl)
{
	
	unsigned char *Udata= new unsigned char[numberOfDataEl];
	
	T *NiftiData=(T*) dataPointer;  
	T max=NiftiData[0];
	T min=NiftiData[1];
	
	for (int i=0;i<numberOfDataEl;i++)
	{
		//cout << NiftiData[i] << " " << endl;
		if (NiftiData[i]>max) max=NiftiData[i];
		if (NiftiData[i]<min) min=NiftiData[i];
	};
	//cout << "Max=" << max << endl;
	//cout << "Min=" << min << endl;
	for (int i=0;i<numberOfDataEl;i++)
	{
		double preCast=NiftiData[i]*255.0/max;
		Udata[i]=(unsigned char) preCast;
	};
	//cout << "Done." << endl; 
	return Udata;
	
};


int
NIFTIIntImage::
PrintMinMaxNrNonZero()
{
	int min=ImageData[0];
	int max=ImageData[0];
	int NrNonZero=0;

	
	for (int i=0;i<numberOfDataEl;i++)
	{
		if (ImageData[i]>max) max=	ImageData[i];
		if (ImageData[i]<min) min=	ImageData[i];
		if (ImageData[i]!=0) NrNonZero++;
	};

	cout << "Min:" << min << endl;
	cout << "Max:" << max << endl;
	cout << "NonZero:" << NrNonZero << "/" <<  numberOfDataEl << endl;

	return 0;
};










template<typename T> int*  GetIntData(T* dataPointer, int numberOfDataEl)
{
	
	int *IntData= new int[numberOfDataEl];
	
	T *NiftiData=(T*) dataPointer;  
	
	for (int i=0;i<numberOfDataEl;i++)
	{
		int preCast=NiftiData[i];
		IntData[i]=(int) preCast;
	};
	//cout << "Done." << endl; 
	return IntData;
	
};




NIFTIIntImage::
NIFTIIntImage()
{
sx=0;
sy=0;
sz=0;
numberOfDataEl=0;
dx=0;
dy=0;
dz=0;
ImageData= NULL;
Udata= NULL;
nim=NULL;
};




NIFTIIntImage::
NIFTIIntImage(NIFTIIntImage *source)
{
	sx=source->sx;
	sy=source->sy;
	sz=source->sz;
	numberOfDataEl=sx*sy*sz;
	dx=source->dx;
	dy=source->dy;
	dz=source->dz;
	ImageData= new int [numberOfDataEl];
	Udata=new unsigned char [numberOfDataEl];
	nbyper=0;
	nim=NULL;
	for (int i=0;i<numberOfDataEl;i++)
	{
		ImageData[i]=0;
		Udata[i]=0;
	};
	
	
};







int
NIFTIIntImage::
DoDimMatch(NIFTIIntImage *source)
{
	if (sx!=source->sx) return 0;
	if (sy!=source->sy) return 0;
	if (sz!=source->sz) return 0;
	return 1;
		
};








NIFTIIntImage::
NIFTIIntImage(int size[3], double d[3])
{
	sx=size[0];
	sy=size[1];
	sz=size[2];
	numberOfDataEl=sx*sy*sz;
	dx=d[0];
	dy=d[1];
	dz=d[2];
	ImageData= new int [numberOfDataEl];
	Udata=new unsigned char [numberOfDataEl];
	nbyper=0;
	nim=NULL;
	for (int i=0;i<numberOfDataEl;i++)
	{
		ImageData[i]=0.0;
		Udata[i]=0;
	};

	
};





int 
NIFTIIntImage::
CopyDataFrom(NIFTIIntImage *source)
{
	if (DoDimMatch(source)==0) return 1;
	for (int i=0;i<numberOfDataEl;i++)
	{
		ImageData[i]=(source->ImageData)[i];
	};
	
	return 0;
};





NIFTIIntImage::
NIFTIIntImage(char *directory, int nr)
{

};

int 
NIFTIIntImage::
AddOne(int x, int y, int z)
{
	int i=x+y*sx+z*sx*sy;
	ImageData[i]=ImageData[i]+1;
	return 0;
	
};

int 
NIFTIIntImage::
SetVoxel(int x, int y, int z, int value)
{
	int i=x+y*sx+z*sx*sy;
	ImageData[i]=value;
	return 0;
};



int
NIFTIIntImage::
GetVoxel(int x, int y, int z)
{
	int i=x+y*sx+z*sx*sy;
	int value=ImageData[i];
				
	return value;
	

};

int  
NIFTIIntImage::
LoadNiftiImage(const char *fin)
{
	
	sprintf(FileName,"%s",fin);
	
	if (nim!=NULL) nifti_image_free(nim);
	nim=NULL;
    /* read input dataset, including data */
	nim = nifti_image_read(FileName, 1);
	if( !nim ) {
		cout << "** failed to read NIfTI image from " << fin << endl;
		return 1;
	}
	

	sx=nim->nx;
	sy=nim->ny;
	sz=nim->nz;
	dx=nim->dx;
	dy=nim->dy;
	dz=nim->dz;
	nbyper =nim->nbyper; //number of bytes per voxel;
	numberOfDataEl=sx*sy*sz;
	//cout << "Number of data el:" << numberOfDataEl << endl;
	//cout << "sx:" << sx << " " << "sy:" << sy << " " << "sz:" << sz << " " << endl;
	//cout << "dx:" << dx << " " << "dy:" << dy << " " << "dz:" << dz << " " << endl;
	//cout << "Number of bytes per voxel (nbyper):" << nbyper << endl;
	
	
	//NIFTI DATA TYPE
	if (Udata!=NULL) {delete [] Udata; Udata=NULL;}; 
	cout << "sform code is:" <<nim->sform_code << endl;
	mat44 sto_xyz=nim->sto_xyz;
	for (int i=0;i<3;i++)
	    {
	      cout << sto_xyz.m[i] [0] << " " <<  sto_xyz.m [i] [1] << " " <<  sto_xyz.m [i] [2] << " " <<  sto_xyz.m[i] [3] << " " << endl;
	    };
	//Udata= new unsigned char[sx*sy*sz];
	switch (nim->datatype)
	{	  
		case DT_BINARY                   :  cout << "  binary (1 bit/voxel)         " << endl; return NULL;break;
		case DT_UNSIGNED_CHAR            :  cout << " unsigned char (8 bits/voxel) " << endl; Udata=GetScaledData((unsigned char*) nim->data, numberOfDataEl); break;
		case DT_SIGNED_SHORT             :  cout << " signed short (16 bits/voxel) " << endl; Udata=GetScaledData((signed short*) nim->data, numberOfDataEl); break;
		case DT_SIGNED_INT               :  cout << " signed int (32 bits/voxel)   " << endl; Udata=GetScaledData((signed int*) nim->data, numberOfDataEl); break;
		case DT_FLOAT                    :  cout << " float (32 bits/voxel)        " << endl; Udata=GetScaledData((float*) nim->data, numberOfDataEl); break;
		case DT_COMPLEX                  :   cout << " complex (64 bits/voxel)      " << endl; return NULL;break;
		case DT_DOUBLE                   :  cout << " double (64 bits/voxel)       " << endl;Udata=GetScaledData((double*) nim->data, numberOfDataEl); break;
		case DT_RGB                      :  cout << " RGB triple (24 bits/voxel)   " << endl; return NULL;break;
		default : 	cout << "Unknown data type" << endl; exit(1); break;
	};
	
	
	if (ImageData!=NULL) delete [] ImageData;
		
	//ImageData= new int[numberOfDataEl];
	
	switch (nim->datatype)
	{	  
		case DT_BINARY                   :  cout << "  binary (1 bit/voxel)         " << endl; return NULL;break;
		case DT_UNSIGNED_CHAR            :  cout << " unsigned char (8 bits/voxel) " << endl; ImageData=GetIntData((unsigned char*) nim->data, numberOfDataEl); break;
		case DT_SIGNED_SHORT             :  cout << " signed short (16 bits/voxel) " << endl; ImageData=GetIntData((signed short*) nim->data, numberOfDataEl); break;
		case DT_SIGNED_INT               :  cout << " signed int (32 bits/voxel)   " << endl; ImageData=GetIntData((signed int*) nim->data, numberOfDataEl); break;
		case DT_FLOAT                    :  cout << " float (32 bits/voxel)        " << endl; ImageData=GetIntData((float*) nim->data, numberOfDataEl); break;
		case DT_COMPLEX                  :   cout << " complex (64 bits/voxel)      " << endl; return NULL;break;
		case DT_DOUBLE                   :  cout << " double (64 bits/voxel)       " << endl; ImageData=GetIntData((double*) nim->data, numberOfDataEl); break;
		case DT_RGB                      :  cout << " RGB triple (24 bits/voxel)   " << endl; return NULL;break;
		default : 	cout << "Unknown data type" << endl; exit(1); break;
	};
	
	
	
	

		
	return 0;

};








int 
NIFTIIntImage::
ConvertIJKtoXYZ(int i, int j, int k, float &x, float &y, float &z)
{cout << "Hello"<< endl;
if (nim->qform_code==0)
	{
	x = (nim->pixdim[1]) * i;
     	y = (nim->pixdim[2]) * j;
     	z = (nim->pixdim[3]) * k;
	return 0;
	};

  float *srow_x=nim->sto_xyz.m[0];
  float *srow_y=nim->sto_xyz.m[1];
  float *srow_z=nim->sto_xyz.m[2];
  x = srow_x[0] * i + srow_x[1] * j + srow_x[2] * k + srow_x[3];
  y = srow_y[0] * i + srow_y[1] * j + srow_y[2] * k + srow_y[3];
  z = srow_z[0] * i + srow_z[1] * j + srow_z[2] * k + srow_z[3];
  return 0;
};





int  
NIFTIIntImage::
WriteNiftiImage(const char *fin)
{
	
	sprintf(FileName,"%s",fin);
	
	if (nim->datatype!=DT_SIGNED_INT)
	{
		cout << "Only signed int (32/bit suported!)" << endl;
		return 1;
	};
		

	//case DT_SIGNED_INT               :  cout << " signed int (32 bits/voxel)   " << endl; ImageData=GetIntData((signed int*) nim->data, numberOfDataEl); break;
	
	int *Pointer=(int*) nim->data;
	for (int i=0;i<numberOfDataEl;i++) Pointer[i]=ImageData[i];
	nifti_set_filenames(nim, FileName, 0, nim->byteorder);
	nifti_image_write   ( nim) ;
	return 0;
};





















vtkImageData*
NIFTIIntImage::
GetVTKImageData()
{
	Udata= new unsigned char[numberOfDataEl];
	for (int i=0;i<numberOfDataEl;i++)
	{
		unsigned char preCast= ImageData[i];
		Udata[i]=(unsigned char) preCast;
	};
	
	//Nifti Data
	vtkUnsignedCharArray *array=vtkUnsignedCharArray::New();
	array->SetArray(Udata, sx*sy*sz,1 );
	
	vtkImageData *imageData=vtkImageData::New();
	(imageData->GetPointData())->SetScalars(array);
	imageData->SetDimensions (sx, sy, sz);
	imageData->SetSpacing	(	dx 	, dy 	, dz);	
	imageData->SetScalarType(VTK_UNSIGNED_CHAR);
	imageData->SetOrigin(0.0,0.0,0.0);
	
	
	return imageData;
}



// Nifti Image Processing 





