//Nifti Image Management 

#ifndef NIFTIINTIMAGE
#define NIFTIINTIMAGE

#include "DataTypes.h"


#define FRONTALCORTEXLEFT 1
#define MOTORCORTEXLEFT 2
#define OCCIPITALCORTEXLEFT 3
#define POSTERIORPARIETALCORTEXLEFT 4
#define SENSORYCORTEXLEFT 5
#define TEMPORALCORETXLEFT 6

extern double ColorFrontalCortexLeft[3];
extern double ColorMotorCortexLeft[3];
extern double ColorOccipitalCortexLeft[3];
extern double ColorPosteriorParietalCortexLeft[3];
extern double ColorSensoryCortexLeft[3];
extern double ColorTemporalCortexLeft[3];


template<typename T> unsigned char*  GetScaledData(T* dataPointer, int numberOfDataEl);
template<typename T> float*  GetFloatData(T* dataPointer, int numberOfDataEl);



class NIFTIIntImage
{
public:
	NIFTIIntImage();
	NIFTIIntImage(NIFTIIntImage *source);
	
	NIFTIIntImage(int size[3], double  d[3]);
	NIFTIIntImage(char *directory, int nr);
	~NIFTIIntImage();
	
	
	int CopyDataFrom(NIFTIIntImage *source);
	
	int LoadNiftiImage(const char *fin);
	int WriteNiftiImage(const char *fin);
	int PrintMinMaxNrNonZero();
	int DoDimMatch(NIFTIIntImage *source);
	
	int GetVoxel(int x, int y, int z);
	int AddOne(int x, int y, int z);
	int SetVoxel(int x, int y, int z, int value);
	int ConvertIJKtoXYZ(int i, int j, int k, float &x, float &y, float &z);

	vtkImageData* GetVTKImageData();

public:
	int sx;
	int sy;
	int sz;
	double dx;
	double dy;
	double dz;
	int numberOfDataEl;
	nifti_image * nim; // does not need to exist 
	int nbyper;
	unsigned char *Udata;
	int *ImageData;


	//ColorManagement 
	double  color[3];
	
	//FileName
	char FileName[120];
	char BaseName[120];
	
};


#endif


