/*
 *  VTKVisualization.h
 *  
 *
 *  Created by Philip Broser on 5/13/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef VTKVIZUALIZATION
#define VTKVIZUALIZATION


#include "DataTypes.h"
#include "NIFTIIntImage.h"
#include "NIFTIFloatImage.h"


vtkActor *GetGlyphActorForPolyData(vtkPolyData *polydata);
vtkActor *GetGlyphActorWithDelaunyForPolyData(vtkPolyData *polydata, int mode);


vtkPolyData* GetPolyDataForTargetImage(NIFTIIntImage* BaseImage);

vtkPolyData* GetPolyDataForMaskWithThresholdAndColor(NIFTIIntImage* BaseImage, float Threshold, unsigned char r, unsigned char g, unsigned char b);
vtkPolyData* GetPolyDataForFloatImageWithThresholdAndColor(NIFTIFloatImage* BaseImage, float Threshold, unsigned char r, unsigned char g, unsigned char b);

vtkActor *GetActorForPolyDataFileName(char* fileName);

vtkActor *GetActorForSmoothPolyDataFileName(char* fileName);



vtkActor* VisualiseCoordinateSystem();
vtkActor* SphereActorForPositionAndColor(float x, float y, float z, float r, float g, float b );
vtkAssembly *SpehereActorsForXYZFile(char *FileName, float r, float g, float b );
list<vtkActor*> ListSpehereActorsForXYZFile(char *FileName, float r, float g, float b );
vtkActor* SphereActorForPositionAndColorAndRadius(float x, float y, float z, float r, float g, float b, float R );
vtkActor* TubeActorForStartStopPositionAndColor(float sx, float sy, float sz,float x, float y, float z, float r, float g, float b );
#endif 
